;; Text macros collection
;; Originally written by Four-F (four-f@mail.ru), Modified and Bug fixed by Cloud(fly04@software.nju.edu.cn)
;; Last updated 17 Aug.,2006
;; Version 0.2 beta
;; Your improvements, suggestions and bugfixes are welcomed.

;; This file is part of KmdKit, an SDK for developing Windows Kernal Mode Drivers with MASM.
;; Copyright by Four-F and Cloud.  

IFNDEF _STRING_INC_
_STRING_INC_ = -1

PUSHCONTEXT	ALL
.NOLIST

;;-------------------------------------------------------------------------------------
;;Constants and global variables used by this macro collection
;;-------------------------------------------------------------------------------------

MALIB_STR_TemporaryString TEXTEQU <>


MALIB_STR_NumStringsInConstAnsi = 0
MALIB_STR_NumStringsInDataAnsi = 0
MALIB_STR_NumStringsInConstUnicode = 0
MALIB_STR_NumStringsInDataUnicode = 0
MALIB_STR_NumStringsInFreeAnsi = 0
MALIB_STR_NumStringsInFreeUnicode = 0

MALIB_STR_NumStringsInConstAnsi0 = 0
MALIB_STR_NumStringsInDataAnsi0 = 0
MALIB_STR_NumStringsInConstUnicode0 = 0
MALIB_STR_NumStringsInDataUnicode0 = 0
MALIB_STR_NumStringsInFreeAnsi0 = 0
MALIB_STR_NumStringsInFreeUnicode0 = 0

MALIB_STR_ConstAnsi0ZeroString TEXTEQU <>
MALIB_STR_DataAnsi0ZeroString TEXTEQU <>
MALIB_STR_ConstUnicode0ZeroString TEXTEQU <>
MALIB_STR_DataUnicode0ZeroString TEXTEQU <>
MALIB_STR_FreeAnsi0ZeroString TEXTEQU <>
MALIB_STR_FreeUnicode0ZeroString TEXTEQU <>

MALIB_STR_ConstAnsi0ZeroStringAlignment TEXTEQU <0>
MALIB_STR_DataAnsi0ZeroStringAlignment TEXTEQU <0>
MALIB_STR_ConstUnicode0ZeroStringAlignment TEXTEQU <0>
MALIB_STR_DataUnicode0ZeroStringAlignment TEXTEQU <0>
MALIB_STR_FreeAnsi0ZeroStringAlignment TEXTEQU <0>
MALIB_STR_FreeUnicode0ZeroStringAlignment TEXTEQU <0>
MALIB_STR_CUT_STEP = 43
MALIB_STR_CHARCOUNT = 0
MALIB_STR_NEWPARSE = 0
MALIB_STR_ISCOMPLETE = 0

;;--------------------------------------------------------------------------------------------------
;;Support Macros for defining unicode strings
;;--------------------------------------------------------------------------------------------------


;;--------------------------------------------------------------------------------------------
;;Macro function returns the number of arguments in a VARARG list.
;;
;;Params:  args - arguments to be counted
;;
;;Affected registers:None
;;--------------------------------------------------------------------------------------------
IFNDEF	$ArgCount
$ArgCount MACRO args:VARARG
LOCAL arg,y
	y = 0
	FOR arg,<&args>
		y = y + 1
	ENDM
	EXITM %y
ENDM
ENDIF

;;------------------------------------------------------------------------------------
;;(Internal)Macro function that removes char not allowed in MASM identifiers from specified text
;;
;;Params: txt - text to remove illeagal char from
;;
;;Affected Registers:None
;;
;;------------------------------------------------------------------------------------
IFNDEF	$RemoveIllegalChar
$RemoveIllegalChar	MACRO	txt:REQ
LOCAL	r, s, bg, len
	
	IF	@InStr(1, txt, <!">)  NE 0
		bg = @InStr(1, txt, <!">)
		bg = bg + 1
		len = @InStr(bg, txt, <!">) - bg
		
		s	CATSTR	@SubStr(txt, 1, bg - 2), @SubStr(txt, bg, len)
	ELSE
		s	TEXTEQU	<txt>
	ENDIF
	r	TEXTEQU	<>
	%FORC	cha, <s>
		IF	"&cha" NE "." AND "&cha" NE "-" AND "&cha" NE "+" AND "&cha" NE " " AND "&cha" NE "*"
			r	CATSTR	r, <cha>
		ENDIF
	ENDM
	EXITM	r
ENDM
ENDIF

;;-------------------------------------------------------------------------------------------
;;(Internal)Macro function that generates an unique label according to given SEGMENT names and SEGMENT parameters
;;
;;Params: segn - SEGMENT name;
;;	  segopt - SEGMENT parameters in SEGMENT declaration
;;
;;No registers involved.
;;---------------------------------------------------------------------------------------------
IFNDEF	$GenUnqSegStrLbl
$GenUnqSegStrLbl	MACRO	segn, segopt
LOCAL	txt
	IFB	<segn>
		txt	CATSTR	<$?>, <defname>
	ELSE
		txt	CATSTR	<$?>, <segn>
	ENDIF
	
	IFB	<segopt>
		txt	CATSTR	txt, <default>
	ELSE
		txt	CATSTR	txt, $RemoveIllegalChar(segopt)
	ENDIF
	
	%IFNDEF	MALIB_STR_NumStringsIn&&txt&&Ansi
	%	MALIB_STR_NumStringsIn&&txt&&Ansi = 0
	ENDIF
	
	%IFNDEF	MALIB_STR_NumStringsIn&&txt&&Unicode
	%	MALIB_STR_NumStringsIn&&txt&&Unicode = 0
	ENDIF
	
	
	%IFNDEF	MALIB_STR_NumStringsIn&&txt&&Ansi0
	%	MALIB_STR_NumStringsIn&&txt&&Ansi0 = 0
	ENDIF
	
	%IFNDEF	MALIB_STR_NumStringsIn&&txt&&Unicode0
	%	MALIB_STR_NumStringsIn&&txt&&Unicode0 = 0
	ENDIF
	
	%IFNDEF	MALIB_STR_&&txt&&Ansi0ZeroString
	%	MALIB_STR_&&txt&&Ansi0ZeroString TEXTEQU <>
	ENDIF
	
	%IFNDEF	MALIB_STR_&&txt&&Unicode0ZeroString
	%	MALIB_STR_&&txt&&Unicode0ZeroString TEXTEQU <>
	ENDIF
	
	%IFNDEF	MALIB_STR_&&txt&&Ansi0ZeroStringAlignment
	%	MALIB_STR_&&txt&&Ansi0ZeroStringAlignment TEXTEQU <0>
	ENDIF
	
	%IFNDEF	MALIB_STR_&&txt&&Unicode0ZeroStringAlignment
	%	MALIB_STR_&&txt&&Unicode0ZeroStringAlignment TEXTEQU <0>
	ENDIF
	
	EXITM	txt
ENDM
ENDIF


;;-----------------------------------------------------------------------------------------------------
;;(Internal)Macro function that separates macro arguments which is too long.
;;Used by older version of some macros
;;
;;------------------------------------------------------------------------------------------------- 
IFNDEF	$ArgCut
$ArgCut	MACRO	bg:REQ, ed:REQ, args:VARARG
LOCAL	arg, y, txt
	y = 0
	txt	TEXTEQU	<>
	FOR arg, <&args>
		y = y + 1
		IF	(y EQ bg)
			txt	CATSTR	txt, <arg>
		ENDIF
		IF	(y GT bg) AND (y LE ed)
			txt	CATSTR	txt, <!,>, <arg>
		ENDIF
	ENDM
	EXITM	txt
ENDM
ENDIF


;;------------------------------------------------------------------------------------------------------
;;(Internal)String parsing MACRO for ansi strings
;;
;;-------------------------------------------------------------------------------------------------------
IFNDEF	STRINGA
STRINGA MACRO _s_
LOCAL txt, str, ac, bslash, lq, sc, fd
	txt TEXTEQU <>
	bslash = 0						;; backslash reached
	lq = 0							;; leading quotation mark ( "...... )
	sc = 0							;; separating comma ( ...,... )
	ac = 0							;; inline ASCII code
	fd = 0							;; first digit? 
	
	str SUBSTR <_s_>, 1

	% FORC cha, <str>
		IF	ac
			IF lq
				txt CATSTR txt, <">					;;"
				lq = 0
				sc = 1
			ENDIF
			IF sc
				txt CATSTR txt, <,>
				sc = 0
			ENDIF
			
			IF	fd AND ((("&cha" GE "A") AND ("&cha" LE "F")) OR (("&cha" GE "a") AND ("&cha" LE "f")))
				txt	CATSTR	txt, <0>
			ENDIF	
			
			IF	("&cha" EQ "h") OR ("&cha" EQ "H")
				ac = 0
				sc = 1
				txt	CATSTR	txt, <&cha>
			ELSE
				IF	(("&cha" GE "A") AND ("&cha" LE "F")) OR (("&cha" GE "a") AND ("&cha" LE "f")) OR (("&cha" GE "0") AND ("&cha" LE "9"))
					txt	CATSTR	txt, <&cha>
				ENDIF
			ENDIF
			
			fd = 0
		ELSE
			IF bslash
				bslash = 0
				IF "&cha" EQ "\"
					IF sc
						txt CATSTR txt, <,>
						sc = 0
					ENDIF
	
					IF lq
						txt CATSTR txt, <&cha>
					ELSE
						txt CATSTR txt, <">, <&cha>			;; add ( ")
						lq = 1								;; set flag
					ENDIF
				ELSE
	
					IF lq
						txt CATSTR txt, <">					;;"
						lq = 0
						sc = 1
					ENDIF
	
					IF sc
						txt CATSTR txt, <,>
					ENDIF
	
					sc = 1
	
					IF 	("&cha" EQ "n") OR ("&cha" EQ "N")	;;  \n   = CR, LF
						txt CATSTR txt, <0Dh,0Ah>
					ELSEIF ("&cha" EQ "r") OR ("&cha" EQ "R")	;;  \r   = CR
						txt CATSTR txt, <0Dh>
					ELSEIF ("&cha" EQ "l") OR ("&cha" EQ "L")	;;  \l   = LF
						txt CATSTR txt, <0Ah>
					ELSEIF "&cha" EQ ":"		;;  \:   = !
						txt CATSTR txt, <21h>
					ELSEIF "&cha" EQ "{"		;;  \{   = (
						txt CATSTR txt, <28h>
					ELSEIF "&cha" EQ "}"		;;  \}   = )
						txt CATSTR txt, <29h>
					ELSEIF "&cha" EQ "["		;;  \[   = <
						txt CATSTR txt, <3Ch>
					ELSEIF "&cha" EQ "]"		;;  \]   = >
						txt CATSTR txt, <3Eh>
					ELSEIF "&cha" EQ "="		;;  \=   = "
						txt CATSTR txt, <22h>
					ELSEIF "&cha" EQ "-"		;;  \-   = '
						txt CATSTR txt, <27h>
					ELSEIF "&cha" EQ "0"		;;  \0   = 0
						txt CATSTR txt, <0h>
					ELSEIF ("&cha" EQ "u") OR ("&cha" EQ "U")
						ac = 1
						sc = 0
						fd = 1
					ELSEIF ("&cha" EQ "a") OR ("&cha" EQ "A")	;;  \a   = BEL
						txt CATSTR txt, <7h>
					ELSEIF ("&cha" EQ "b") OR ("&cha" EQ "B")	;;  \b   = BS
						txt CATSTR txt, <8h>
					ELSEIF ("&cha" EQ "t") OR ("&cha" EQ "T")	;;  \t   = HT
						txt CATSTR txt, <9h>
					ELSEIF ("&cha" EQ "v") OR ("&cha" EQ "V")	;;  \v   = VT
						txt CATSTR txt, <0Bh>
					ELSEIF ("&cha" EQ "f") OR ("&cha" EQ "F")	;;  \f   = FF
						txt CATSTR txt, <0Ch>
					ELSEIF "&cha" EQ "*"		;;  \*   = *nothing*
						;; Add nothing. Workaround against "CreateFile" -> "CreateFileA" problem.
						;; See above KNOWN PROBLEMS for details.
						sc = 0
					ELSE
						txt CATSTR txt, <"&cha">
						echo WARNING!: '&cha' : unrecognized character escape sequence
						;; This also can be used to workaround against "CreateFile" -> "CreateFileA" problem.
						;; See above KNOWN PROBLEMS for details.
					ENDIF
				ENDIF
			ELSE
				IF "&cha" EQ "\"
					bslash = 1
				ELSE
					IF sc
						txt CATSTR txt, <,>
						sc = 0
					ENDIF
					IF lq
						txt CATSTR txt, <&cha>
					ELSE
						txt CATSTR txt, <">, <&cha>			;; add leading ( " )
						lq = 1								;; set flag
					ENDIF
				ENDIF
			ENDIF
		ENDIF
	ENDM

	IF lq
		txt CATSTR txt, <">					;;"
	ENDIF

	EXITM <txt>
ENDM
ENDIF

;;---------------------------------------------------------------------------------------------------------
;;(Internal)String parsing MACRO for unicode strings
;;
;;---------------------------------------------------------------------------------------------------------

IFNDEF	STRINGW
STRINGW MACRO _s_
LOCAL 	txt, str, bslash, lq, sc, ac, fd, nw
	txt TEXTEQU <>
	bslash = 0						;; backslash reached
	lq = 0							;; leading quotation mark ( "...... )
	sc = 0							;; separating comma ( ...,... )
	ac = 0
	fd = 0
	MALIB_STR_CHARCOUNT = 0
	nw = MALIB_STR_NEWPARSE
	MALIB_STR_ISCOMPLETE = 1
	
	str SUBSTR <_s_>, 1

	% FORC cha, <str>
		IF	ac
			IF lq
				txt CATSTR txt, <">					;;"
				lq = 0
				sc = 1
			ENDIF
			IF sc				
				MALIB_STR_CHARCOUNT = MALIB_STR_CHARCOUNT + 1
				IF MALIB_STR_CHARCOUNT LE MALIB_STR_CUT_STEP
					txt CATSTR txt, <,>
					sc = 0
				ELSE
					IF nw EQ 0
						MALIB_STR_ISCOMPLETE = 0						
						EXITM <txt>
					ELSE
						txt TEXTEQU	<>
						sc = 0
						nw = nw - 1
						MALIB_STR_CHARCOUNT = 0
					ENDIF
					
				ENDIF
				
			ENDIF
			
			IF	fd AND ((("&cha" GE "A") AND ("&cha" LE "F")) OR (("&cha" GE "a") AND ("&cha" LE "f")))
				txt	CATSTR	txt, <0>
			ENDIF	
			
			IF	("&cha" EQ "h") OR ("&cha" EQ "H")
				ac = 0
				sc = 1
				txt	CATSTR	txt, <&cha>
			ELSE
				IF	(("&cha" GE "A") AND ("&cha" LE "F")) OR (("&cha" GE "a") AND ("&cha" LE "f")) OR (("&cha" GE "0") AND ("&cha" LE "9"))
					txt	CATSTR	txt, <&cha>
				ENDIF
			ENDIF
			
			fd = 0
		ELSE
			IF bslash
				bslash = 0
				IF "&cha" EQ "\"					
					IF sc
						MALIB_STR_CHARCOUNT = MALIB_STR_CHARCOUNT + 1
						IF MALIB_STR_CHARCOUNT LE MALIB_STR_CUT_STEP
							txt CATSTR txt, <,>
							sc = 0
						ELSE
							IF nw EQ 0
								MALIB_STR_ISCOMPLETE = 0
								EXITM <txt>
							ELSE
								txt TEXTEQU	<>
								sc = 0
								nw = nw - 1
								MALIB_STR_CHARCOUNT = 0
							ENDIF
							
						ENDIF
					ENDIF
					txt CATSTR txt, <"&cha">
					sc = 1
				ELSE
				
					IF lq
						txt CATSTR txt, <">					;;"
						lq = 0
						sc = 1
					ENDIF
		
					IF sc
						MALIB_STR_CHARCOUNT = MALIB_STR_CHARCOUNT + 1
						IF MALIB_STR_CHARCOUNT LE MALIB_STR_CUT_STEP
							txt CATSTR txt, <,>
							sc = 0
						ELSE
							IF nw EQ 0
								MALIB_STR_ISCOMPLETE = 0
								EXITM <txt>
							ELSE
								txt TEXTEQU	<>
								sc = 0
								nw = nw - 1
								MALIB_STR_CHARCOUNT = 0
							ENDIF
							
						ENDIF
					ENDIF
	
					sc = 1
	
					IF ("&cha" EQ "n") OR ("&cha" EQ "N")		;;  \n   = CR, LF
						txt CATSTR txt, <0Dh,0Ah>
					ELSEIF ("&cha" EQ "r") OR ("&cha" EQ "R")		;;  \r   = CR
						txt CATSTR txt, <0Dh>
					ELSEIF ("&cha" EQ "l") OR ("&cha" EQ "L")		;;  \l   = LF
						txt CATSTR txt, <0Ah>
					ELSEIF "&cha" EQ ":"		;;  \:   = !
						txt CATSTR txt, <21h>
					ELSEIF "&cha" EQ "{"		;;  \{   = (
						txt CATSTR txt, <28h>
					ELSEIF "&cha" EQ "}"		;;  \}   = )
						txt CATSTR txt, <29h>
					ELSEIF "&cha" EQ "["		;;  \[   = <
						txt CATSTR txt, <3Ch>
					ELSEIF "&cha" EQ "]"		;;  \]   = >
						txt CATSTR txt, <3Eh>
					ELSEIF "&cha" EQ "="		;;  \=   = "
						txt CATSTR txt, <22h>
					ELSEIF "&cha" EQ "-"		;;  \-   = '
						txt CATSTR txt, <27h>
					ELSEIF "&cha" EQ "0"		;;  \0   = 0
						txt CATSTR txt, <0h>
					ELSEIF ("&cha" EQ "u") OR ("&cha" EQ "U")
						ac = 1
						sc = 0
						fd = 1
					ELSEIF ("&cha" EQ "a") OR ("&cha" EQ "A")	;;  \a   = BEL
						txt CATSTR txt, <7h>
					ELSEIF ("&cha" EQ "b") OR ("&cha" EQ "B")	;;  \b   = BS
						txt CATSTR txt, <8h>
					ELSEIF ("&cha" EQ "t") OR ("&cha" EQ "T")	;;  \t   = HT
						txt CATSTR txt, <9h>
					ELSEIF ("&cha" EQ "v") OR ("&cha" EQ "V")	;;  \v   = VT
						txt CATSTR txt, <0Bh>
					ELSEIF ("&cha" EQ "f") OR ("&cha" EQ "F")	;;  \f   = FF
						txt CATSTR txt, <0Ch>
					ELSEIF "&cha" EQ "*"		;;  \*   = *nothing*
						;; Add nothing. Workaround against "CreateFile" -> "CreateFileA" problem.
						;; See above LIMITATIONS for details.
						sc = 0
					ELSE
						txt CATSTR txt, <"&cha">
						echo WARNING!: '&cha' : unrecognized character escape sequence
						;; This also can be used to workaround against "CreateFile" -> "CreateFileA" problem.
						;; See above LIMITATIONS for details.
					ENDIF
				ENDIF
			ELSE
				IF "&cha" EQ "\"
					bslash = 1
				ELSE
					IF sc
						MALIB_STR_CHARCOUNT = MALIB_STR_CHARCOUNT + 1
						IF MALIB_STR_CHARCOUNT LE MALIB_STR_CUT_STEP
							txt CATSTR txt, <,>
							sc = 0
						ELSE
							IF nw EQ 0
								MALIB_STR_ISCOMPLETE = 0
								EXITM <txt>
							ELSE
								txt TEXTEQU	<>
								sc = 0
								nw = nw - 1
								MALIB_STR_CHARCOUNT = 0
							ENDIF
							
						ENDIF
					ENDIF
					txt CATSTR txt, <"&cha">
					sc = 1
				ENDIF
			ENDIF
		ENDIF
	ENDM	

	EXITM <txt>
ENDM
ENDIF

;;---------------------------------------------------------------------------------------------------
;;                              MACROS NOT TERMINATING STRING WITH ZERO                              
;;--------------------------------------------------------------------------------------------------

;;--------------------------------------------------------------------------------------------------
;;                                       TA /CTA / TW / CTW                                          
;;--------------------------------------------------------------------------------------------------
IFNDEF	TA
TA MACRO txt, lora, aorl
	local d, aln, sn, line, tms, bg, ed

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	sn TEXTEQU @CurSeg

	.data
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF
	ELSE
		;;ALIGN aln
		;;d db 0
		;; Do not let define empty string with TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : TA macro ERROR! To define empty string use TA0
		.ERR
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF

IFNDEF	CTA
CTA MACRO txt, lora, aorl
	local d, aln, sn, line, tms, bg, ed

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	sn TEXTEQU @CurSeg

	.const
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF
	ELSE
		;;ALIGN aln
		;;d db 0
		;; Do not let define empty string with CTA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : CTA macro ERROR! To define empty string use CTA0
		.ERR
	ENDIF

	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF


IFNDEF	TW
TW MACRO txt, lora, aorl
	local d, aln, sn, line

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : TW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	sn TEXTEQU @CurSeg

	.data
	IF @SizeStr(%MALIB_STR_TemporaryString)		
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
	ELSE
		;;ALIGN aln
		;;d dw 0
		;; Do not let define empty string with TW macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : TW macro ERROR! To define empty string use TW0
		.ERR		
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF


IFNDEF	CTW
CTW MACRO txt, lora, aorl
	local d, aln, sn, line

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : CTW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	sn TEXTEQU @CurSeg

	.const
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
	ELSE
		;;ALIGN aln
		;;d dw 0
		;; Do not let define empty string with CTW macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : CTW macro ERROR! To define empty string use CTW0
		.ERR	
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF


IFNDEF	T
T MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			TW txt, lora, aorl
		ELSE
			TA txt, lora, aorl
		ENDIF
	ELSE
		TA txt, lora, aorl
	ENDIF
ENDM
ENDIF


IFNDEF	CT
CT MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			CTW txt, lora, aorl
		ELSE
			CTA txt, lora, aorl
		ENDIF
	ELSE
		CTA txt, lora, aorl
	ENDIF
ENDM
ENDIF


;;-------------------------------------------------------------------------------------------------
;;                                      $TA / $CTA / $TW / $CTW                                      
;;-------------------------------------------------------------------------------------------------
IFNDEF	$CTA
$CTA MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, line, tms, bg, ed
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $CTA macro ERROR! To define empty string use $CTA0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0		
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInConstAnsi

			IF len EQ @SizeStr(%@CatStr(<MALIB_STR_ConstAnsiStringNo>, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(<MALIB_STR_ConstAnsiStringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(<MALIB_STR_ConstAnsiOffsetNo>, %(count))

					IF aln GT @CatStr(<MALIB_STR_ConstAnsiAlignmentNo>, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $CTA macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInConstAnsi
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.const
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING
				
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			

			MALIB_STR_NumStringsInConstAnsi = MALIB_STR_NumStringsInConstAnsi + 1
	
			@CatStr(<MALIB_STR_ConstAnsiStringNo>, %(MALIB_STR_NumStringsInConstAnsi)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_ConstAnsiOffsetNo>, %(MALIB_STR_NumStringsInConstAnsi)) TEXTEQU <d>
			@CatStr(<MALIB_STR_ConstAnsiAlignmentNo>, %(MALIB_STR_NumStringsInConstAnsi)) TEXTEQU <aln>
			
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInConstAnsi = MALIB_STR_NumStringsInConstAnsi + 1
		
				@CatStr(<MALIB_STR_ConstAnsiStringNo>, %(MALIB_STR_NumStringsInConstAnsi)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_ConstAnsiOffsetNo>, %(MALIB_STR_NumStringsInConstAnsi)) TEXTEQU <d>
				@CatStr(<MALIB_STR_ConstAnsiAlignmentNo>, %(MALIB_STR_NumStringsInConstAnsi)) TEXTEQU <aln>	
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$CTW
$CTW MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, line
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $CTW macro ERROR! To define empty string use $CTW0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0
			defineit = 1	
		ELSE
			defineit = 0	
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $CTW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInConstUnicode

			IF len EQ @SizeStr(%@CatStr(<MALIB_STR_ConstUnicodeStringNo>, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(<MALIB_STR_ConstUnicodeStringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(<MALIB_STR_ConstUnicodeOffsetNo>, %(count))

					IF aln GT @CatStr(<MALIB_STR_ConstUnicodeAlignmentNo>, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $CTW macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInConstUnicode
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.const
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInConstUnicode = MALIB_STR_NumStringsInConstUnicode + 1
	
			@CatStr(<MALIB_STR_ConstUnicodeStringNo>, %(MALIB_STR_NumStringsInConstUnicode)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_ConstUnicodeOffsetNo>, %(MALIB_STR_NumStringsInConstUnicode)) TEXTEQU <d>
			@CatStr(<MALIB_STR_ConstUnicodeAlignmentNo>, %(MALIB_STR_NumStringsInConstUnicode)) TEXTEQU <aln>
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInConstUnicode = MALIB_STR_NumStringsInConstUnicode + 1
		
				@CatStr(<MALIB_STR_ConstUnicodeStringNo>, %(MALIB_STR_NumStringsInConstUnicode)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_ConstUnicodeOffsetNo>, %(MALIB_STR_NumStringsInConstUnicode)) TEXTEQU <d>
				@CatStr(<MALIB_STR_ConstUnicodeAlignmentNo>, %(MALIB_STR_NumStringsInConstUnicode)) TEXTEQU <aln>	
			ENDIF
		
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$CT
$CT MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $CTW(txt, lora, aorl)
		ELSE
			EXITM $CTA(txt, lora, aorl)
		ENDIF
	ELSE
		EXITM $CTA(txt, lora, aorl)
	ENDIF
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$TA
$TA MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, line, tms, bg, ed
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $TA macro ERROR! To define empty string use $TA0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInDataAnsi

			IF len EQ @SizeStr(%@CatStr(<MALIB_STR_DataAnsiStringNo>, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(<MALIB_STR_DataAnsiStringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(<MALIB_STR_DataAnsiOffsetNo>, %(count))

					IF aln GT @CatStr(<MALIB_STR_DataAnsiAlignmentNo>, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $TA macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInDataAnsi
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.data
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInDataAnsi = MALIB_STR_NumStringsInDataAnsi + 1
	
			@CatStr(<MALIB_STR_DataAnsiStringNo>, %(MALIB_STR_NumStringsInDataAnsi)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_DataAnsiOffsetNo>, %(MALIB_STR_NumStringsInDataAnsi)) TEXTEQU <d>
			@CatStr(<MALIB_STR_DataAnsiAlignmentNo>, %(MALIB_STR_NumStringsInDataAnsi)) TEXTEQU <aln>
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInDataAnsi = MALIB_STR_NumStringsInDataAnsi + 1
		
				@CatStr(<MALIB_STR_DataAnsiStringNo>, %(MALIB_STR_NumStringsInDataAnsi)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_DataAnsiOffsetNo>, %(MALIB_STR_NumStringsInDataAnsi)) TEXTEQU <d>
				@CatStr(<MALIB_STR_DataAnsiAlignmentNo>, %(MALIB_STR_NumStringsInDataAnsi)) TEXTEQU <aln>
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$TW
$TW MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, line
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TW macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $TW macro ERROR! To define empty string use $TW0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 1
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $TW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF
	
	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInDataUnicode

			IF len EQ @SizeStr(%@CatStr(<MALIB_STR_DataUnicodeStringNo>, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(<MALIB_STR_DataUnicodeStringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(<MALIB_STR_DataUnicodeOffsetNo>, %(count))

					IF aln GT @CatStr(<MALIB_STR_DataUnicodeAlignmentNo>, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $TW macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInDataUnicode
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.data
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInDataUnicode = MALIB_STR_NumStringsInDataUnicode + 1
	
			@CatStr(<MALIB_STR_DataUnicodeStringNo>, %(MALIB_STR_NumStringsInDataUnicode)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_DataUnicodeOffsetNo>, %(MALIB_STR_NumStringsInDataUnicode)) TEXTEQU <d>
			@CatStr(<MALIB_STR_DataUnicodeAlignmentNo>, %(MALIB_STR_NumStringsInDataUnicode)) TEXTEQU <aln>
		ELSE
			IF	DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInDataUnicode = MALIB_STR_NumStringsInDataUnicode + 1
		
				@CatStr(<MALIB_STR_DataUnicodeStringNo>, %(MALIB_STR_NumStringsInDataUnicode)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_DataUnicodeOffsetNo>, %(MALIB_STR_NumStringsInDataUnicode)) TEXTEQU <d>
				@CatStr(<MALIB_STR_DataUnicodeAlignmentNo>, %(MALIB_STR_NumStringsInDataUnicode)) TEXTEQU <aln>
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$T
$T MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $TW(txt, lora, aorl)
		ELSE
			EXITM $TA(txt, lora, aorl)
		ENDIF
	ELSE
		EXITM $TA(txt, lora, aorl)
	ENDIF
ENDM
ENDIF

;;--------------------------------------------------------------------------------------------------
;;                               MACROS TERMINATING STRING WITH ZERO                                 
;;---------------------------------------------------------------------------------------------------

;;---------------------------------------------------------------------------------------------------
;;                                     TA0 / CTA0 / TW0 / CTW0                                       
;;---------------------------------------------------------------------------------------------------
IFNDEF	TA0
TA0 MACRO txt, lora, aorl
	local d, aln, sn, tms, bg, ed

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	sn TEXTEQU @CurSeg

	.data
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString), 0
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
			DB 	0
		ENDIF
	ELSE
		ALIGN aln
		d db 0		
	ENDIF

	@CurSeg ENDS
	sn SEGMENT
	
ENDM
ENDIF


IFNDEF	TW0
TW0 MACRO txt, lora, aorl
	local d, aln, sn, line

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : TW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	sn TEXTEQU @CurSeg

	.data
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		dw	0
	ELSE
		ALIGN aln
		d dw 0		
	ENDIF

	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF


IFNDEF	T0
T0 MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			TW0 txt, lora, aorl
		ELSE
			TA0 txt, lora, aorl
		ENDIF
	ELSE
		TA0 txt, lora, aorl
	ENDIF
ENDM
ENDIF


IFNDEF	CTA0
CTA0 MACRO txt, lora, aorl
	local d, aln, sn, tms, bg, ed

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	sn TEXTEQU @CurSeg

	.const
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString), 0
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
			db	0
		ENDIF
	ELSE
		ALIGN aln
		d db 0		
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	CTW0
CTW0 MACRO txt, lora, aorl
	local d, aln, sn, line

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : CTW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	sn TEXTEQU @CurSeg

	.const
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		dw	0
		
	ELSE
		ALIGN aln
		d dw 0		
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT
ENDM
ENDIF


IFNDEF	CT0
CT0 MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			CTW0 txt, lora, aorl
		ELSE
			CTA0 txt, lora, aorl
		ENDIF
	ELSE
		CTA0 txt, lora, aorl
	ENDIF
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                     $TA0 / $CTA0 / $TW0 / $CTW0                                   
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$TA0
$TA0 MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, tms, bg, ed

	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInDataAnsi0

				IF len EQ @SizeStr(%@CatStr(<MALIB_STR_DataAnsi0StringNo>, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(<MALIB_STR_DataAnsi0StringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(<MALIB_STR_DataAnsi0OffsetNo>, %(count))

						IF aln GT @CatStr(<MALIB_STR_DataAnsi0AlignmentNo>, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $TA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInDataAnsi0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_DataAnsi0ZeroString)
				d TEXTEQU MALIB_STR_DataAnsi0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_DataAnsi0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $TA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.data
		IF len NE 0
			ALIGN aln
			tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
			IF	tms EQ 0
				d db STRINGA(%MALIB_STR_TemporaryString), 0
			ELSE
				bg = 1
				ed = MALIB_STR_CUT_STEP
				d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				REPEAT tms
					bg = bg + MALIB_STR_CUT_STEP
					ed = ed + MALIB_STR_CUT_STEP
					IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
						ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ENDIF
					DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				ENDM
				db	0
			ENDIF
		ELSE
			ALIGN aln
			d db 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInDataAnsi0 = MALIB_STR_NumStringsInDataAnsi0 + 1
	
			@CatStr(<MALIB_STR_DataAnsi0StringNo>, %(MALIB_STR_NumStringsInDataAnsi0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_DataAnsi0OffsetNo>, %(MALIB_STR_NumStringsInDataAnsi0)) TEXTEQU <d>
			@CatStr(<MALIB_STR_DataAnsi0AlignmentNo>, %(MALIB_STR_NumStringsInDataAnsi0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_DataAnsi0ZeroString TEXTEQU <d>
				MALIB_STR_DataAnsi0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInDataAnsi0 = MALIB_STR_NumStringsInDataAnsi0 + 1
		
				@CatStr(<MALIB_STR_DataAnsi0StringNo>, %(MALIB_STR_NumStringsInDataAnsi0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_DataAnsi0OffsetNo>, %(MALIB_STR_NumStringsInDataAnsi0)) TEXTEQU <d>
				@CatStr(<MALIB_STR_DataAnsi0AlignmentNo>, %(MALIB_STR_NumStringsInDataAnsi0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_DataAnsi0ZeroString TEXTEQU <d>
					MALIB_STR_DataAnsi0ZeroStringAlignment TEXTEQU <aln>
				ENDIF
			ENDIF

		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$TW0
$TW0 MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, line

	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $TW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInDataUnicode0

				IF len EQ @SizeStr(%@CatStr(<MALIB_STR_DataUnicode0StringNo>, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(<MALIB_STR_DataUnicode0StringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(<MALIB_STR_DataUnicode0OffsetNo>, %(count))

						IF aln GT @CatStr(<MALIB_STR_DataUnicode0AlignmentNo>, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $TW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInDataUnicode0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_DataUnicode0ZeroString)
				d TEXTEQU MALIB_STR_DataUnicode0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_DataUnicode0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $TW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.data
		IF len NE 0
			ALIGN aln
			MALIB_STR_NEWPARSE = 0			
			d dw STRINGW(%MALIB_STR_TemporaryString)
			WHILE	MALIB_STR_ISCOMPLETE EQ 0
				MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
				dw	STRINGW(%MALIB_STR_TemporaryString)
			ENDM
			dw	0
		ELSE
			ALIGN aln
			d dw 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInDataUnicode0 = MALIB_STR_NumStringsInDataUnicode0 + 1
	
			@CatStr(<MALIB_STR_DataUnicode0StringNo>, %(MALIB_STR_NumStringsInDataUnicode0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_DataUnicode0OffsetNo>, %(MALIB_STR_NumStringsInDataUnicode0)) TEXTEQU <d>
			@CatStr(<MALIB_STR_DataUnicode0AlignmentNo>, %(MALIB_STR_NumStringsInDataUnicode0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_DataUnicode0ZeroString TEXTEQU <d>
				MALIB_STR_DataUnicode0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF	DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInDataUnicode0 = MALIB_STR_NumStringsInDataUnicode0 + 1
		
				@CatStr(<MALIB_STR_DataUnicode0StringNo>, %(MALIB_STR_NumStringsInDataUnicode0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_DataUnicode0OffsetNo>, %(MALIB_STR_NumStringsInDataUnicode0)) TEXTEQU <d>
				@CatStr(<MALIB_STR_DataUnicode0AlignmentNo>, %(MALIB_STR_NumStringsInDataUnicode0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_DataUnicode0ZeroString TEXTEQU <d>
					MALIB_STR_DataUnicode0ZeroStringAlignment TEXTEQU <aln>
				ENDIF	
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$T0
$T0 MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $TW0(txt, lora, aorl)
		ELSE
			EXITM $TA0(txt, lora, aorl)
		ENDIF
	ELSE
		EXITM $TA0(txt, lora, aorl)
	ENDIF
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$CTA0
$CTA0 MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, tms, bg, ed

	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0	
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInConstAnsi0

				IF len EQ @SizeStr(%@CatStr(<MALIB_STR_ConstAnsi0StringNo>, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(<MALIB_STR_ConstAnsi0StringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(<MALIB_STR_ConstAnsi0OffsetNo>, %(count))

						IF aln GT @CatStr(<MALIB_STR_ConstAnsi0AlignmentNo>, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $CTA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInConstAnsi0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_ConstAnsi0ZeroString)
				d TEXTEQU MALIB_STR_ConstAnsi0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_ConstAnsi0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $CTA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.const
		IF len NE 0
			ALIGN aln
			tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
			IF	tms EQ 0
				d db STRINGA(%MALIB_STR_TemporaryString), 0
			ELSE
				bg = 1
				ed = MALIB_STR_CUT_STEP
				d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				REPEAT tms
					bg = bg + MALIB_STR_CUT_STEP
					ed = ed + MALIB_STR_CUT_STEP
					IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
						ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ENDIF
					DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				ENDM
				db	0
			ENDIF
		ELSE
			ALIGN aln
			d db 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInConstAnsi0 = MALIB_STR_NumStringsInConstAnsi0 + 1
			
			@CatStr(<MALIB_STR_ConstAnsi0StringNo>, %(MALIB_STR_NumStringsInConstAnsi0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_ConstAnsi0OffsetNo>, %(MALIB_STR_NumStringsInConstAnsi0)) TEXTEQU <d>
			@CatStr(<MALIB_STR_ConstAnsi0AlignmentNo>, %(MALIB_STR_NumStringsInConstAnsi0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_ConstAnsi0ZeroString TEXTEQU <d>
				MALIB_STR_ConstAnsi0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInConstAnsi0 = MALIB_STR_NumStringsInConstAnsi0 + 1
				
				@CatStr(<MALIB_STR_ConstAnsi0StringNo>, %(MALIB_STR_NumStringsInConstAnsi0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_ConstAnsi0OffsetNo>, %(MALIB_STR_NumStringsInConstAnsi0)) TEXTEQU <d>
				@CatStr(<MALIB_STR_ConstAnsi0AlignmentNo>, %(MALIB_STR_NumStringsInConstAnsi0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_ConstAnsi0ZeroString TEXTEQU <d>
					MALIB_STR_ConstAnsi0ZeroStringAlignment TEXTEQU <aln>
				ENDIF
			ENDIF	
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$CTW0
$CTW0 MACRO txt, lora, aorl
	local d, aln, sn, count, defineit, len, line
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $CTW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInConstUnicode0

				IF len EQ @SizeStr(%@CatStr(<MALIB_STR_ConstUnicode0StringNo>, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(<MALIB_STR_ConstUnicode0StringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(<MALIB_STR_ConstUnicode0OffsetNo>, %(count))

						IF aln GT @CatStr(<MALIB_STR_ConstUnicode0AlignmentNo>, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $CTW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInConstUnicode0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_ConstUnicode0ZeroString)
				d TEXTEQU MALIB_STR_ConstUnicode0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_ConstUnicode0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $CTW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		.const
		IF len NE 0
			ALIGN aln
			MALIB_STR_NEWPARSE = 0			
			d dw STRINGW(%MALIB_STR_TemporaryString)
			WHILE	MALIB_STR_ISCOMPLETE EQ 0
				MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
				dw	STRINGW(%MALIB_STR_TemporaryString)
			ENDM
			dw	0									
		ELSE
			ALIGN aln
			d dw 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInConstUnicode0 = MALIB_STR_NumStringsInConstUnicode0 + 1
	
			@CatStr(<MALIB_STR_ConstUnicode0StringNo>, %(MALIB_STR_NumStringsInConstUnicode0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_ConstUnicode0OffsetNo>, %(MALIB_STR_NumStringsInConstUnicode0)) TEXTEQU <d>
			@CatStr(<MALIB_STR_ConstUnicode0AlignmentNo>, %(MALIB_STR_NumStringsInConstUnicode0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_ConstUnicode0ZeroString TEXTEQU <d>
				MALIB_STR_ConstUnicode0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInConstUnicode0 = MALIB_STR_NumStringsInConstUnicode0 + 1
		
				@CatStr(<MALIB_STR_ConstUnicode0StringNo>, %(MALIB_STR_NumStringsInConstUnicode0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_ConstUnicode0OffsetNo>, %(MALIB_STR_NumStringsInConstUnicode0)) TEXTEQU <d>
				@CatStr(<MALIB_STR_ConstUnicode0AlignmentNo>, %(MALIB_STR_NumStringsInConstUnicode0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_ConstUnicode0ZeroString TEXTEQU <d>
					MALIB_STR_ConstUnicode0ZeroStringAlignment TEXTEQU <aln>
				ENDIF
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$CT0
$CT0 MACRO txt, lora, aorl
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $CTW0(txt, lora, aorl)
		ELSE
			EXITM $CTA0(txt, lora, aorl)
		ENDIF
	ELSE
		EXITM $CTA0(txt, lora, aorl)
	ENDIF
ENDM
ENDIF

;;Added by Cloud
;;FT, $FT, FTA, $FTA, FTW, $FTW, FT0, $FT0, FTA0, $FTA0, .......(Seems no use in dos), Free SEGMENT name
;;===============================================================================================
IFNDEF	FTA
FTA MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, line, tms, bg, ed

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF
	
	sn TEXTEQU @CurSeg
	
	IFB	<segname>
		.data
	ELSE
		@CurSeg ENDS
		IFIDN	@SubStr(segname, 1, 1), <.>
			segname
		ELSE 
			segname	SEGMENT opt
		ENDIF
	ENDIF
	
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF
	ELSE
		;;ALIGN aln
		;;d db 0
		;; Do not let define empty string with TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : FTA macro ERROR! To define empty string use FTA0
		.ERR
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF


IFNDEF	FTW
FTW MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, line

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : TW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	sn TEXTEQU @CurSeg

	IFB	<segname>
		.data
	ELSE
		@CurSeg ENDS
		IFIDN	@SubStr(segname, 1, 1), <.>
			segname
		ELSE 
			segname	SEGMENT opt
		ENDIF
	ENDIF
	
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
	ELSE
		;;ALIGN aln
		;;d dw 0
		;; Do not let define empty string with TW macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : FTW macro ERROR! To define empty string use FTW0
		.ERR		
	ENDIF
	
	@CurSeg ENDS
	sn SEGMENT

ENDM
ENDIF


IFNDEF	FT
FT MACRO txt, lora, aorl, segname, opt
	IFDEF UNICODE
		IF UNICODE NE 0
			FTW txt, lora, aorl, segname, opt
		ELSE
			FTA txt, lora, aorl, segname, opt
		ENDIF
	ELSE
		FTA txt, lora, aorl, segname, opt
	ENDIF
ENDM
ENDIF

;;--------------------------------------------------------------------------------------------------
;;                                      $FTA/$FTW/$FT                                
;;--------------------------------------------------------------------------------------------------
IFNDEF	$FTA
$FTA MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, line, tms, bg, ed
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $FTA macro ERROR! To define empty string use $FTA0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInFreeAnsi

			IF len EQ @SizeStr(%@CatStr(<MALIB_STR_FreeAnsiStringNo>, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(<MALIB_STR_FreeAnsiStringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(<MALIB_STR_FreeAnsiOffsetNo>, %(count))

					IF aln GT @CatStr(<MALIB_STR_FreeAnsiAlignmentNo>, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $FTA macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInFreeAnsi
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;
	
	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg
		
		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInFreeAnsi = MALIB_STR_NumStringsInFreeAnsi + 1
	
			@CatStr(<MALIB_STR_FreeAnsiStringNo>, %(MALIB_STR_NumStringsInFreeAnsi)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_FreeAnsiOffsetNo>, %(MALIB_STR_NumStringsInFreeAnsi)) TEXTEQU <d>
			@CatStr(<MALIB_STR_FreeAnsiAlignmentNo>, %(MALIB_STR_NumStringsInFreeAnsi)) TEXTEQU <aln>
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInFreeAnsi = MALIB_STR_NumStringsInFreeAnsi + 1
		
				@CatStr(<MALIB_STR_FreeAnsiStringNo>, %(MALIB_STR_NumStringsInFreeAnsi)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_FreeAnsiOffsetNo>, %(MALIB_STR_NumStringsInFreeAnsi)) TEXTEQU <d>
				@CatStr(<MALIB_STR_FreeAnsiAlignmentNo>, %(MALIB_STR_NumStringsInFreeAnsi)) TEXTEQU <aln>
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$FTW
$FTW MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, line
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $FTW macro ERROR! To define empty string use $FTW0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $FTW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInFreeUnicode

			IF len EQ @SizeStr(%@CatStr(<MALIB_STR_FreeUnicodeStringNo>, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(<MALIB_STR_FreeUnicodeStringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(<MALIB_STR_FreeUnicodeOffsetNo>, %(count))

					IF aln GT @CatStr(<MALIB_STR_FreeUnicodeAlignmentNo>, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $FTW macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInFreeUnicode
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg
		
		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInFreeUnicode = MALIB_STR_NumStringsInFreeUnicode + 1
	
			@CatStr(<MALIB_STR_FreeUnicodeStringNo>, %(MALIB_STR_NumStringsInFreeUnicode)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_FreeUnicodeOffsetNo>, %(MALIB_STR_NumStringsInFreeUnicode)) TEXTEQU <d>
			@CatStr(<MALIB_STR_FreeUnicodeAlignmentNo>, %(MALIB_STR_NumStringsInFreeUnicode)) TEXTEQU <aln>
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInFreeUnicode = MALIB_STR_NumStringsInFreeUnicode + 1
		
				@CatStr(<MALIB_STR_FreeUnicodeStringNo>, %(MALIB_STR_NumStringsInFreeUnicode)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_FreeUnicodeOffsetNo>, %(MALIB_STR_NumStringsInFreeUnicode)) TEXTEQU <d>
				@CatStr(<MALIB_STR_FreeUnicodeAlignmentNo>, %(MALIB_STR_NumStringsInFreeUnicode)) TEXTEQU <aln>
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$FT
$FT MACRO txt, lora, aorl, segname, opt
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $FTW(txt, lora, aorl, segname, opt)
		ELSE
			EXITM $FTA(txt, lora, aorl, segname, opt)
		ENDIF
	ELSE
		EXITM $FTA(txt, lora, aorl, segname, opt)
	ENDIF
ENDM
ENDIF


;;--------------------------------------------------------------------------------------------------
;;                               MACROS TERMINATING STRING WITH ZERO                                 
;;--------------------------------------------------------------------------------------------------

;;--------------------------------------------------------------------------------------------------
;;                                     FTA0 / FTW0                                       
;;--------------------------------------------------------------------------------------------------
IFNDEF	FTA0
FTA0 MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, tms, bg, ed

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	sn TEXTEQU @CurSeg

	IFB	<segname>
		.data
	ELSE
		@CurSeg ENDS
		IFIDN	@SubStr(segname, 1, 1), <.>
			segname
		ELSE 
			segname	SEGMENT opt
		ENDIF
	ENDIF
	
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString), 0
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
			db	0
		ENDIF
	ELSE
		ALIGN aln
		d db 0		
	ENDIF

	@CurSeg ENDS
	sn SEGMENT
	
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	FTW0
FTW0 MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, line

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : FTW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	sn TEXTEQU @CurSeg
	
	IFB	<segname>
		.data
	ELSE
		@CurSeg ENDS
		IFIDN	@SubStr(segname, 1, 1), <.>
			segname
		ELSE 
			segname	SEGMENT opt
		ENDIF
	ENDIF
	
	IF @SizeStr(%MALIB_STR_TemporaryString)
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		DW 0
	ELSE
		ALIGN aln
		d dw 0		
	ENDIF

	@CurSeg ENDS
	sn SEGMENT
ENDM
ENDIF


IFNDEF	FT0
FT0 MACRO txt, lora, aorl, segname, opt
	IFDEF UNICODE
		IF UNICODE NE 0
			FTW0 txt, lora, aorl, segname, opt
		ELSE
			FTA0 txt, lora, aorl, segname, opt
		ENDIF
	ELSE
		FTA0 txt, lora, aorl, segname, opt
	ENDIF
ENDM
ENDIF

;;---------------------------------------------------------------------------------------------------
;;                                     $FTA0 / $FTW0                                   
;;---------------------------------------------------------------------------------------------------
IFNDEF	$FTA0
$FTA0 MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, tms, bg, ed

	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 1
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInFreeAnsi0

				IF len EQ @SizeStr(%@CatStr(<MALIB_STR_FreeAnsi0StringNo>, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(<MALIB_STR_FreeAnsi0StringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(<MALIB_STR_FreeAnsi0OffsetNo>, %(count))

						IF aln GT @CatStr(<MALIB_STR_FreeAnsi0AlignmentNo>, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $FTA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInFreeAnsi0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_FreeAnsi0ZeroString)
				d TEXTEQU MALIB_STR_FreeAnsi0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_FreeAnsi0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $FTA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		IF len NE 0
			ALIGN aln
			tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
			IF	tms EQ 0
				d db STRINGA(%MALIB_STR_TemporaryString), 0
			ELSE
				bg = 1
				ed = MALIB_STR_CUT_STEP
				d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				REPEAT tms
					bg = bg + MALIB_STR_CUT_STEP
					ed = ed + MALIB_STR_CUT_STEP
					IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
						ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ENDIF
					DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				ENDM
				db	0
			ENDIF
		ELSE
			ALIGN aln
			d db 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInFreeAnsi0 = MALIB_STR_NumStringsInFreeAnsi0 + 1
			
			@CatStr(<MALIB_STR_FreeAnsi0StringNo>, %(MALIB_STR_NumStringsInFreeAnsi0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_FreeAnsi0OffsetNo>, %(MALIB_STR_NumStringsInFreeAnsi0)) TEXTEQU <d>
			@CatStr(<MALIB_STR_FreeAnsi0AlignmentNo>, %(MALIB_STR_NumStringsInFreeAnsi0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_FreeAnsi0ZeroString TEXTEQU <d>
				MALIB_STR_FreeAnsi0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF 	DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInFreeAnsi0 = MALIB_STR_NumStringsInFreeAnsi0 + 1
				
				@CatStr(<MALIB_STR_FreeAnsi0StringNo>, %(MALIB_STR_NumStringsInFreeAnsi0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_FreeAnsi0OffsetNo>, %(MALIB_STR_NumStringsInFreeAnsi0)) TEXTEQU <d>
				@CatStr(<MALIB_STR_FreeAnsi0AlignmentNo>, %(MALIB_STR_NumStringsInFreeAnsi0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_FreeAnsi0ZeroString TEXTEQU <d>
					MALIB_STR_FreeAnsi0ZeroStringAlignment TEXTEQU <aln>
				ENDIF
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$FTW0
$FTW0 MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, line

	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $FTW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInFreeUnicode0

				IF len EQ @SizeStr(%@CatStr(<MALIB_STR_FreeUnicode0StringNo>, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(<MALIB_STR_FreeUnicode0StringNo>, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(<MALIB_STR_FreeUnicode0OffsetNo>, %(count))

						IF aln GT @CatStr(<MALIB_STR_FreeUnicode0AlignmentNo>, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $FTW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInFreeUnicode0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_FreeUnicode0ZeroString)
				d TEXTEQU MALIB_STR_FreeUnicode0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_FreeUnicode0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $FTW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg
		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		IF len NE 0
			ALIGN aln
			MALIB_STR_NEWPARSE = 0			
			d dw STRINGW(%MALIB_STR_TemporaryString)
			WHILE	MALIB_STR_ISCOMPLETE EQ 0
				MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
				dw	STRINGW(%MALIB_STR_TemporaryString)
			ENDM
			DW 0
		ELSE
			ALIGN aln
			d dw 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInFreeUnicode0 = MALIB_STR_NumStringsInFreeUnicode0 + 1
	
			@CatStr(<MALIB_STR_FreeUnicode0StringNo>, %(MALIB_STR_NumStringsInFreeUnicode0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(<MALIB_STR_FreeUnicode0OffsetNo>, %(MALIB_STR_NumStringsInFreeUnicode0)) TEXTEQU <d>
			@CatStr(<MALIB_STR_FreeUnicode0AlignmentNo>, %(MALIB_STR_NumStringsInFreeUnicode0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_FreeUnicode0ZeroString TEXTEQU <d>
				MALIB_STR_FreeUnicode0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInFreeUnicode0 = MALIB_STR_NumStringsInFreeUnicode0 + 1
		
				@CatStr(<MALIB_STR_FreeUnicode0StringNo>, %(MALIB_STR_NumStringsInFreeUnicode0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(<MALIB_STR_FreeUnicode0OffsetNo>, %(MALIB_STR_NumStringsInFreeUnicode0)) TEXTEQU <d>
				@CatStr(<MALIB_STR_FreeUnicode0AlignmentNo>, %(MALIB_STR_NumStringsInFreeUnicode0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_FreeUnicode0ZeroString TEXTEQU <d>
					MALIB_STR_FreeUnicode0ZeroStringAlignment TEXTEQU <aln>
				ENDIF
			ENDIF

		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$FT0
$FT0 MACRO txt, lora, aorl, segname, opt
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $FTW0(txt, lora, aorl, segname, opt)
		ELSE
			EXITM $FTA0(txt, lora, aorl, segname, opt)
		ENDIF
	ELSE
		EXITM $FTA0(txt, lora, aorl, segname, opt)
	ENDIF
ENDM
ENDIF


;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
;                                      $$FTA/$$FTW/$$FT                                
;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

IFNDEF	$$FTA
$$FTA MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, line, tms, bg, ed
	LOCAL MALIB_STR_NumStringsInAnsi, MALIB_STR_AnsiStringNo,MALIB_STR_AnsiOffsetNo, MALIB_STR_AnsiAlignmentNo
	
	MALIB_STR_NumStringsInAnsi	CATSTR	<MALIB_STR_NumStringsIn>, $GenUnqSegStrLbl(segname, opt), <Ansi>
	MALIB_STR_AnsiStringNo	CATSTR <MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <AnsiStringNo>
	MALIB_STR_AnsiOffsetNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <AnsiOffsetNo>
	MALIB_STR_AnsiAlignmentNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <AnsiAlignmentNo>
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $$FTA macro ERROR! To define empty string use $$FTA0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		
		WHILE (count LE MALIB_STR_NumStringsInAnsi)

			IF len EQ @SizeStr(%@CatStr(%MALIB_STR_AnsiStringNo, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(%MALIB_STR_AnsiStringNo, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(%MALIB_STR_AnsiOffsetNo, %(count))

					IF aln GT @CatStr(%MALIB_STR_AnsiAlignmentNo, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $$FTA macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInAnsi
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;
	
	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg
		
		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		
		ALIGN aln
		tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
		IF	tms EQ 0
			d db STRINGA(%MALIB_STR_TemporaryString)
		ELSE
			bg = 1
			ed = MALIB_STR_CUT_STEP
			d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			REPEAT tms
				bg = bg + MALIB_STR_CUT_STEP
				ed = ed + MALIB_STR_CUT_STEP
				IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
				ENDIF
				DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
			ENDM
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
			
			MALIB_STR_NumStringsInAnsi = MALIB_STR_NumStringsInAnsi + 1
			
			@CatStr(%MALIB_STR_AnsiStringNo, %(MALIB_STR_NumStringsInAnsi)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(%MALIB_STR_AnsiOffsetNo, %(MALIB_STR_NumStringsInAnsi)) TEXTEQU <d>
			@CatStr(%MALIB_STR_AnsiAlignmentNo, %(MALIB_STR_NumStringsInAnsi)) TEXTEQU <aln>
		ELSE
			IF DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInAnsi = MALIB_STR_NumStringsInAnsi + 1
				
				@CatStr(%MALIB_STR_AnsiStringNo, %(MALIB_STR_NumStringsInAnsi)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(%MALIB_STR_AnsiOffsetNo, %(MALIB_STR_NumStringsInAnsi)) TEXTEQU <d>
				@CatStr(%MALIB_STR_AnsiAlignmentNo, %(MALIB_STR_NumStringsInAnsi)) TEXTEQU <aln>
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$$FTW
$$FTW MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, line
	LOCAL MALIB_STR_NumStringsInUnicode, MALIB_STR_UnicodeStringNo,MALIB_STR_UnicodeOffsetNo, MALIB_STR_UnicodeAlignmentNo
	
	MALIB_STR_NumStringsInUnicode	CATSTR	<MALIB_STR_NumStringsIn>, $GenUnqSegStrLbl(segname, opt), <Unicode>
	MALIB_STR_UnicodeStringNo	CATSTR <MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <UnicodeStringNo>
	MALIB_STR_UnicodeOffsetNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <UnicodeOffsetNo>
	MALIB_STR_UnicodeAlignmentNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <UnicodeAlignmentNo>
	
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	IF len EQ 0
		;; Do not let define empty string with $TA macro
		;; because it defines non-zero terminating strings.
		;; So, empty non-zero terminating string... What's this for?
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $$FTW macro ERROR! To define empty string use $$FTW0
		.ERR
	ENDIF
			
	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0		
			defineit = 1
		ELSE
			defineit = 0	
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $$FTW macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		count = 1
		WHILE count LE MALIB_STR_NumStringsInUnicode

			IF len EQ @SizeStr(%@CatStr(%MALIB_STR_UnicodeStringNo, %(count)))
				;; Lenght the same. Let's compare.
				IF @InStr(1, %@CatStr(%MALIB_STR_UnicodeStringNo, %(count)), %MALIB_STR_TemporaryString) EQ 1 
					;; This string was found in base
					defineit = 0		;; Don't add it in base
					d TEXTEQU @CatStr(%MALIB_STR_UnicodeOffsetNo, %(count))

					IF aln GT @CatStr(%MALIB_STR_UnicodeAlignmentNo, %(count))
						line TEXTEQU %@Line
						% ECHO @FileCur(line) : $$FTW macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
					ENDIF

					;; Break the loop
					count = MALIB_STR_NumStringsInUnicode
				ENDIF
			ENDIF
			count = count + 1
		ENDM

	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg
		
		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		d dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInUnicode = MALIB_STR_NumStringsInUnicode + 1
	
			@CatStr(%MALIB_STR_UnicodeStringNo, %(MALIB_STR_NumStringsInUnicode)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(%MALIB_STR_UnicodeOffsetNo, %(MALIB_STR_NumStringsInUnicode)) TEXTEQU <d>
			@CatStr(%MALIB_STR_UnicodeAlignmentNo, %(MALIB_STR_NumStringsInUnicode)) TEXTEQU <aln>
		ELSE
			IF 	DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInUnicode = MALIB_STR_NumStringsInUnicode + 1
		
				@CatStr(%MALIB_STR_UnicodeStringNo, %(MALIB_STR_NumStringsInUnicode)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(%MALIB_STR_UnicodeOffsetNo, %(MALIB_STR_NumStringsInUnicode)) TEXTEQU <d>
				@CatStr(%MALIB_STR_UnicodeAlignmentNo, %(MALIB_STR_NumStringsInUnicode)) TEXTEQU <aln>	
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$$FT
$$FT MACRO txt, lora, aorl, segname, opt
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $$FTW(txt, lora, aorl, segname, opt)
		ELSE
			EXITM $$FTA(txt, lora, aorl, segname, opt)
		ENDIF
	ELSE
		EXITM $$FTA(txt, lora, aorl, segname, opt)
	ENDIF
ENDM
ENDIF

;;-------------------------------------------------------------------------------------------------
;;                                  $$FTA0 / $$FTW0 / $$FT0
;;-------------------------------------------------------------------------------------------------

IFNDEF	$$FTA0
$$FTA0 MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, tms, bg, ed
	LOCAL MALIB_STR_NumStringsInAnsi0, MALIB_STR_Ansi0StringNo,MALIB_STR_Ansi0OffsetNo, MALIB_STR_Ansi0AlignmentNo, MALIB_STR_Ansi0ZeroString, MALIB_STR_Ansi0ZeroStringAlignment
	
	MALIB_STR_NumStringsInAnsi0	CATSTR	<MALIB_STR_NumStringsIn>, $GenUnqSegStrLbl(segname, opt), <Ansi0>
	MALIB_STR_Ansi0StringNo	CATSTR <MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Ansi0StringNo>
	MALIB_STR_Ansi0OffsetNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Ansi0OffsetNo>
	MALIB_STR_Ansi0AlignmentNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Ansi0AlignmentNo>
	MALIB_STR_Ansi0ZeroString	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Ansi0ZeroString>
	MALIB_STR_Ansi0ZeroStringAlignment	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Ansi0ZeroStringAlignment>
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <1>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	;;
	;; Search in base for this string
	;;
	IF defineit EQ 0

		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInAnsi0

				IF len EQ @SizeStr(%@CatStr(%MALIB_STR_Ansi0StringNo, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(%MALIB_STR_Ansi0StringNo, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(%MALIB_STR_Ansi0OffsetNo, %(count))

						IF aln GT @CatStr(%MALIB_STR_Ansi0AlignmentNo, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $$FTA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInAnsi0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%@CatStr(%MALIB_STR_Ansi0ZeroString, <>))
				d TEXTEQU MALIB_STR_Ansi0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_Ansi0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $$FTA0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg

		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		IF len NE 0
			ALIGN aln
			tms = ($ArgCount(%STRINGA(%MALIB_STR_TemporaryString)) - 1) / MALIB_STR_CUT_STEP
			IF	tms EQ 0
				d db STRINGA(%MALIB_STR_TemporaryString), 0
			ELSE
				bg = 1
				ed = MALIB_STR_CUT_STEP
				d DB $ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				REPEAT tms
					bg = bg + MALIB_STR_CUT_STEP
					ed = ed + MALIB_STR_CUT_STEP
					IF	ed GT $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
						ed = $ArgCount(%STRINGA(%MALIB_STR_TemporaryString))
					ENDIF
					DB	$ArgCut(bg, ed, %STRINGA(%MALIB_STR_TemporaryString))
				ENDM
				db	0
			ENDIF
		ELSE
			ALIGN aln
			d db 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInAnsi0 = MALIB_STR_NumStringsInAnsi0 + 1			
			
			@CatStr(%MALIB_STR_Ansi0StringNo, %(MALIB_STR_NumStringsInAnsi0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(%MALIB_STR_Ansi0OffsetNo, %(MALIB_STR_NumStringsInAnsi0)) TEXTEQU <d>
			@CatStr(%MALIB_STR_Ansi0AlignmentNo, %(MALIB_STR_NumStringsInAnsi0)) TEXTEQU <aln>

			IFE @SizeStr(%MALIB_STR_TemporaryString)
				@CatStr(MALIB_STR_Ansi0ZeroString, <>) TEXTEQU <d>
				@CatStr(MALIB_STR_Ansi0ZeroStringAlignment, <>) TEXTEQU <aln>
			ENDIF
			
		ELSE
			IF	DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInAnsi0 = MALIB_STR_NumStringsInAnsi0 + 1			
				
				@CatStr(%MALIB_STR_Ansi0StringNo, %(MALIB_STR_NumStringsInAnsi0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(%MALIB_STR_Ansi0OffsetNo, %(MALIB_STR_NumStringsInAnsi0)) TEXTEQU <d>
				@CatStr(%MALIB_STR_Ansi0AlignmentNo, %(MALIB_STR_NumStringsInAnsi0)) TEXTEQU <aln>
	
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					@CatStr(MALIB_STR_Ansi0ZeroString, <>) TEXTEQU <d>
					@CatStr(MALIB_STR_Ansi0ZeroStringAlignment, <>) TEXTEQU <aln>
				ENDIF
			ENDIF

		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF


IFNDEF	$$FTW0
$$FTW0 MACRO txt, lora, aorl, segname, opt
	local d, aln, sn, count, defineit, len, line
	LOCAL MALIB_STR_NumStringsInUnicode0, MALIB_STR_Unicode0StringNo,MALIB_STR_Unicode0OffsetNo, MALIB_STR_Unicode0AlignmentNo, MALIB_STR_Unicode0ZeroString, MALIB_STR_Unicode0ZeroStringAlignment
	
	MALIB_STR_NumStringsInUnicode0	CATSTR	<MALIB_STR_NumStringsIn>, $GenUnqSegStrLbl(segname, opt), <Unicode0>
	MALIB_STR_Unicode0StringNo	CATSTR <MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Unicode0StringNo>
	MALIB_STR_Unicode0OffsetNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Unicode0OffsetNo>
	MALIB_STR_Unicode0AlignmentNo	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Unicode0AlignmentNo>
	MALIB_STR_Unicode0ZeroString	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Unicode0ZeroString>
	MALIB_STR_Unicode0ZeroStringAlignment	CATSTR	<MALIB_STR_>, $GenUnqSegStrLbl(segname, opt), <Unicode0ZeroStringAlignment>
	;; defineit - flag: 1 - define this string
	;;                  0 - do not define

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	;; If DISABLE_STRING_POOLING defined, disable double-definition tracking

	IFDEF DISABLE_STRING_POOLING
		IF 	DISABLE_STRING_POOLING NE 0
			defineit = 1
		ELSE
			defineit = 0
		ENDIF
		
	ELSE
		defineit = 0
	ENDIF

	;;
	;; What about label and alignment
	;;
	
	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			d TEXTEQU <lora>
			defineit = 1
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			d TEXTEQU <aorl>
			defineit = 1
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $$FTW0 macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	;;
	;; Search in base for this string
	;;

	IF defineit EQ 0
	
		defineit = 1

		IF len NE 0
			count = 1
			WHILE count LE MALIB_STR_NumStringsInUnicode0

				IF len EQ @SizeStr(%@CatStr(%MALIB_STR_Unicode0StringNo, %(count)))
					;; Lenght the same. Let's compare.
					IF @InStr(1, %@CatStr(%MALIB_STR_Unicode0StringNo, %(count)), %MALIB_STR_TemporaryString) EQ 1 
						;; This string was found in base
						defineit = 0		;; Don't add it in base
						d TEXTEQU @CatStr(%MALIB_STR_Unicode0OffsetNo, %(count))

						IF aln GT @CatStr(%MALIB_STR_Unicode0AlignmentNo, %(count))
							line TEXTEQU %@Line
							% ECHO @FileCur(line) : $$FTW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
						ENDIF

						;; Break the loop
						count = MALIB_STR_NumStringsInUnicode0
					ENDIF
				ENDIF
				count = count + 1
			ENDM
		ELSE
			;; Empty string
			IF @SizeStr(%MALIB_STR_Unicode0ZeroString)
				d TEXTEQU MALIB_STR_Unicode0ZeroString
				defineit = 0		;; Don't add it in base
			
				IF aln GT MALIB_STR_Unicode0ZeroStringAlignment
					line TEXTEQU %@Line
					% ECHO @FileCur(line) : $$FTW0 macro WARNING! Alignment is greater then previous instance of "&MALIB_STR_TemporaryString&".
				ENDIF

			ENDIF
		ENDIF
	ENDIF	;; IF defineit EQ 0

	;;
	;; To be or not to be?
	;;

	IF defineit EQ 1

		;; If string previously defined but label for this text passed to macro define it anyway

		sn TEXTEQU @CurSeg
		IFB	<segname>
			.data
		ELSE
			@CurSeg ENDS
			IFIDN	@SubStr(segname, 1, 1), <.>
				segname
			ELSE 
				segname	SEGMENT opt
			ENDIF
		ENDIF
		IF len NE 0
			ALIGN aln
			MALIB_STR_NEWPARSE = 0			
			d dw STRINGW(%MALIB_STR_TemporaryString)
			WHILE	MALIB_STR_ISCOMPLETE EQ 0
				MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
				dw	STRINGW(%MALIB_STR_TemporaryString)
			ENDM
			dw	0
		ELSE
			ALIGN aln
			d dw 0							;; empty str
		ENDIF

		@CurSeg ENDS
		sn SEGMENT

		IFNDEF DISABLE_STRING_POOLING		
			;; If DISABLE_STRING_POOLING defined, disable double-definition tracking
			;;
			;; Add string and its offset to database
			;;
	
			MALIB_STR_NumStringsInUnicode0 = MALIB_STR_NumStringsInUnicode0 + 1
	
			@CatStr(%MALIB_STR_Unicode0StringNo, %(MALIB_STR_NumStringsInUnicode0)) TEXTEQU MALIB_STR_TemporaryString
			@CatStr(%MALIB_STR_Unicode0OffsetNo, %(MALIB_STR_NumStringsInUnicode0)) TEXTEQU <d>
			@CatStr(%MALIB_STR_Unicode0AlignmentNo, %(MALIB_STR_NumStringsInUnicode0)) TEXTEQU <aln>
	
			IFE @SizeStr(%MALIB_STR_TemporaryString)
				MALIB_STR_Unicode0ZeroString TEXTEQU <d>
				MALIB_STR_Unicode0ZeroStringAlignment TEXTEQU <aln>
			ENDIF
		ELSE
			IF	DISABLE_STRING_POOLING EQ 0
				MALIB_STR_NumStringsInUnicode0 = MALIB_STR_NumStringsInUnicode0 + 1
		
				@CatStr(%MALIB_STR_Unicode0StringNo, %(MALIB_STR_NumStringsInUnicode0)) TEXTEQU MALIB_STR_TemporaryString
				@CatStr(%MALIB_STR_Unicode0OffsetNo, %(MALIB_STR_NumStringsInUnicode0)) TEXTEQU <d>
				@CatStr(%MALIB_STR_Unicode0AlignmentNo, %(MALIB_STR_NumStringsInUnicode0)) TEXTEQU <aln>
		
				IFE @SizeStr(%MALIB_STR_TemporaryString)
					MALIB_STR_Unicode0ZeroString TEXTEQU <d>
					MALIB_STR_Unicode0ZeroStringAlignment TEXTEQU <aln>
				ENDIF	
			ENDIF
		ENDIF

	ENDIF

	EXITM <offset d>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF	$FT0
$FT0 MACRO txt, lora, aorl, segname, opt
	IFDEF UNICODE
		IF UNICODE NE 0
			EXITM $FTW0(txt, lora, aorl, segname, opt)
		ELSE
			EXITM $FTA0(txt, lora, aorl, segname, opt)
		ENDIF
	ELSE
		EXITM $FTA0(txt, lora, aorl, segname, opt)
	ENDIF
ENDM
ENDIF

;;-------------------------------------------------------------------------------------------------
;;                    COUNTED_UNICODE_STRING / $COUNTED_UNICODE_STRING                              
;;                    CCOUNTED_UNICODE_STRING / $CCOUNTED_UNICODE_STRING                             
;;-------------------------------------------------------------------------------------------------

IFNDEF UNICODE_STRING
	UNICODE_STRING STRUCT
		woLength		WORD	?		;; len of string in bytes (not chars)
		MaximumLength	WORD	?		;; len of Buffer in bytes (not chars)
		Buffer			DWORD	?		;; pointer to string
	UNICODE_STRING ENDS
	PUNICODE_STRING	typedef	PTR UNICODE_STRING
ENDIF


IFNDEF COUNTED_UNICODE_STRING
COUNTED_UNICODE_STRING MACRO txt, lora, aorl

	local dum, segn, us, line, len

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			us TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			us TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : COUNTED_UNICODE_STRING macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	segn TEXTEQU @CurSeg

	.data
	IF len NE 0
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		dum dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		DW 0
	ELSE
		ALIGN aln
		dum dw 0		
	ENDIF

	ALIGN 4

	us UNICODE_STRING {(MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2-2+4, (MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2+4, offset dum}

	@CurSeg ENDS
	segn SEGMENT
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF CCOUNTED_UNICODE_STRING
CCOUNTED_UNICODE_STRING MACRO txt, lora, aorl

	local dum, segn, us, line, len
	
	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			us TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			us TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : CCOUNTED_UNICODE_STRING macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	segn TEXTEQU @CurSeg

	.const
	IF len NE 0
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		dum dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		DW 0
	ELSE
		ALIGN aln
		dum dw 0		
	ENDIF

	ALIGN 4

	us UNICODE_STRING {(MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2-2+4, (MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2+4, offset dum}

	@CurSeg ENDS
	segn SEGMENT
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF $COUNTED_UNICODE_STRING
$COUNTED_UNICODE_STRING MACRO txt, lora, aorl

	local dum, segn, us, line, len

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			us TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			us TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $COUNTED_UNICODE_STRING macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	segn TEXTEQU @CurSeg

	.data
	IF len NE 0
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		dum dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		dw	0
	ELSE
		ALIGN aln
		dum dw 0		
	ENDIF

	ALIGN 4

	us UNICODE_STRING {(MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2-2+4, (MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2+4, offset dum}
	@CurSeg ENDS
	segn SEGMENT
	EXITM <offset us>
ENDM
ENDIF

;:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
IFNDEF $CCOUNTED_UNICODE_STRING
$CCOUNTED_UNICODE_STRING MACRO txt, lora, aorl

	local dum, segn, us, line, len

	;; remove quotation marks if not empty string

	IFNB <txt>
		MALIB_STR_TemporaryString SUBSTR <txt>, 2, @SizeStr(<txt>) - 2
	ELSE
		MALIB_STR_TemporaryString TEXTEQU <>
	ENDIF

	len TEXTEQU @SizeStr(%MALIB_STR_TemporaryString)

	aln TEXTEQU <2>

	IFNB <lora>
		IF (OPATTR (lora)) AND 00000100y	;; immediate value ?
			;; yes -> lora is alignment
			aln TEXTEQU %lora
		ELSE
			;; no -> lora is label
			us TEXTEQU <lora>
		ENDIF
	ENDIF

	IFNB <aorl>
		IF (OPATTR (aorl)) AND 00000100y	;; immediate value ?
			;; yes -> aorl is alignment
			aln TEXTEQU %aorl
		ELSE
			;; no -> aorl is label
			us TEXTEQU <aorl>
		ENDIF
	ENDIF

	IF aln LT 2
		line TEXTEQU %@Line
		% ECHO @FileCur(line) : $CCOUNTED_UNICODE_STRING macro WARNING! Alignment for Unicode string must be at least 2 bytes.
	ENDIF

	segn TEXTEQU @CurSeg

	.const
	IF len NE 0
		ALIGN aln
		MALIB_STR_NEWPARSE = 0			
		dum dw STRINGW(%MALIB_STR_TemporaryString)
		WHILE	MALIB_STR_ISCOMPLETE EQ 0
			MALIB_STR_NEWPARSE = MALIB_STR_NEWPARSE + 1
			dw	STRINGW(%MALIB_STR_TemporaryString)
		ENDM
		dw	0
	ELSE
		ALIGN aln
		dum dw 0		
	ENDIF

	ALIGN 4

	us UNICODE_STRING {(MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2-2+4, (MALIB_STR_CUT_STEP * MALIB_STR_NEWPARSE + MALIB_STR_CHARCOUNT)*2+4, offset dum}
	@CurSeg ENDS
	segn SEGMENT
	EXITM <offset us>
ENDM
ENDIF

.LIST
POPCONTEXT	ALL
;;End of file
ENDIF ;;String.inc